#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include	<sys/types.h>
#include	<errno.h>
#include	<fcntl.h>
#include <fcntl.h>
#include "error.h"


void set_fl(int fd, int flags)
{
 int val;
 if ((val=fcntl(fd,F_GETFL,0)) <0)
    err_sys("fcntl F_GETFL error");
 val |= flags; /*turn on flags*/
 if (fcntl(fd,F_SETFL,val) <0)
    err_sys("fcntl F_SETFL error");
}

void clr_fl(int fd, int flags)
{
 int val;
 if ((val=fcntl(fd,F_GETFL,0)) <0)
    err_sys("fcntl F_GETFL error");
 val &= ~flags; /*turn off flags*/
 if (fcntl(fd,F_SETFL,val) <0)
    err_sys("fcntl F_SETFL error");
}

char	buf[1000000],*ptr;
int main()
{
	int		i,ntowrite, nwrite;
        fd_set writeset;

	ntowrite = read(0, buf, sizeof(buf));
	fprintf(stderr, "read %d bytes\n", ntowrite);
	set_fl(1, O_NONBLOCK); /* set nonblocking */
	for (ptr = buf; ntowrite > 0; ) {
                FD_ZERO(&writeset);
                FD_SET(1,&writeset);
                if ( ((i=select(2,NULL,&writeset,NULL,NULL)) == -1) && (errno == EINTR)) continue;
		errno = 0;
		nwrite = write(1, ptr, ntowrite);
		fprintf(stderr, "nwrite = %d, errno = %d\n", nwrite, errno);
		if (nwrite > 0) {
			ptr += nwrite;
			ntowrite -= nwrite;
		}
	}

	clr_fl(1, O_NONBLOCK); /* clear nonblocking */
	exit(0);
}
