/*    pipew.c  */
/*    pipew <blksize> */
#include  <sys/types.h>
#include <string.h>
#include <strings.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "error.h"

int main(int argc, char *argv[])
{
   int fdpr[2], fdpw[2];
   char buffr[1024];
   char buffw[1024];
   char buffer[9000000];
   int  blks;
   int  filesize;
   int  wl,rl,srl=0;


   if (argc != 2)
      err_quit("usage: pipew <blocksize>");
   blks=atoi(argv[1]);
   filesize=blks*1024;
   pipe(fdpw);
   pipe(fdpr);
   fprintf(stderr,"\nPipe-Descriptoren fpdw: read %d, write %d\n",fdpw[0],fdpw[1]);
   fprintf(stderr,"Pipe-Descriptoren fpdr: read %d, write %d\n\n",fdpr[0],fdpr[1]);
   if (!fork()) { 
      /*spamc - client*/
      /* Lesezyklus  Eingabe von 0, Blocksize=variable  */
      dup2(fdpw[0],0);
      close(fdpw[0]); close(fdpw[1]);
      fprintf(stderr,"    spamc: Pipe-Descriptoren read 0=%d, Blocks=%d, blksize=1024\n",fdpw[0],blks);
      while (srl < filesize) {
        rl=read(0,&buffer[srl],1024); 
	if ( rl <0 ) break;
	srl = srl + rl;
      }
      fprintf(stderr,"    spamc: readlength=%d    fertig\n",srl);

      /* Schreibzyklus: Ausgabe Puffer nach 1, Blocksize variable */
      dup2(fdpr[1],1);
      close(fdpr[0]); close(fdpr[1]);
      fprintf(stderr,"    spamc: Pipe-Descriptoren write 1=%d, filesize=%d\n",fdpr[1], filesize);
      wl=write(1,buffer,filesize);
      fprintf(stderr,"    spamc: writelength=%d    fertig\n",wl);

      exit(0);
   }
   /*milter-filter - parent */
   /* Schreibzyklus nach fdpw[1], Blocksize=1024*/
   close(fdpw[0]);
   fprintf(stderr,"Milter-filter: Pipe-Descriptoren : write-pipe=%d\n",fdpw[1]);
   while ( srl < filesize ) {
       wl=write(fdpw[1],buffw,1024);
       if ( wl <=0 ) continue;
       srl=srl+wl;
   }
   fprintf(stderr,"Milter-filter: writelength=%d - fertig\n",srl);

   /* Lesezyklus von fdpr[0], Blocksize=1024 */
   close(fdpr[1]);
   fprintf(stderr,"Milter-filter: Pipe-Descriptoren : read-pipe %d, blksize=1024\n",fdpr[0]);
   srl=0;
   while ( srl < filesize ) {
       rl=read(fdpr[0],buffr,1024);
       fprintf(stderr,"Milter-filter: read lgt=%d\n",rl);
       if ( rl < 0 ) break;
       srl=srl+rl;
   }
   fprintf(stderr,"Milter-filter: readlength=%d - fertig\n",srl);
   exit(0);
}
